<?php
/*************************************************************************************/
/*                                                                                   */
/*      Thelia	                                                            		 */
/*                                                                                   */
/*      Copyright (c) Octolys Development		                                     */
/*		email : thelia@octolys.fr		        	                             	 */
/*      web : http://www.octolys.fr						   							 */
/*                                                                                   */
/*      This program is free software; you can redistribute it and/or modify         */
/*      it under the terms of the GNU General Public License as published by         */
/*      the Free Software Foundation; either version 2 of the License, or            */
/*      (at your option) any later version.                                          */
/*                                                                                   */
/*      This program is distributed in the hope that it will be useful,              */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of               */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                */
/*      GNU General Public License for more details.                                 */
/*                                                                                   */
/*      You should have received a copy of the GNU General Public License            */
/*      along with this program; if not, write to the Free Software                  */
/*      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA    */
/*                                                                                   */
/*************************************************************************************/
?>
<?php

	include_once(realpath(dirname(__FILE__)) . "/../../../classes/PluginsClassiques.class.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Variable.class.php");
	
	class Multifonds extends PluginsClassiques{
		
		var $id;
		var $fondbase;
		var $idfond;
		var $fond;
		var $id_parent;
        
		var $table="multifonds";
		var $bddvars = array("id", "fondbase", "idfond", "fond", "id_parent");

		function Multifonds() {
			$this->PluginsClassiques();
		}
				
		
		function init(){

			$cnx = new Cnx();
			$query = "
					CREATE TABLE IF NOT EXISTS `multifonds` (
  					`id` int(11) NOT NULL AUTO_INCREMENT,
  					`fondbase` text NOT NULL,
  					`idfond` int(11) NOT NULL,
  					`fond` text NOT NULL,
  					`id_parent` TINYINT NOT NULL,
 					 PRIMARY KEY (`id`)
					) AUTO_INCREMENT=1 ;";
         	    
			$resul = mysql_query($query, $cnx->link);						
		}	

        function demarrage()
        {
        	global $fond;

			$rewrite = new Variable("rewrite");
			$reecriture = new Reecriture($_REQUEST['url']);
			if($rewrite->valeur && !empty($reecriture->param))
			{
				$id_contenu = lireVarUrl('id_contenu', $reecriture->param);
				$id_dossier = lireVarUrl('id_dossier', $reecriture->param);
				$id_rubrique = lireVarUrl('id_rubrique', $reecriture->param);
				$id_produit = lireVarUrl('id_produit', $reecriture->param);
			} 
			else
			{
				$id_contenu = lireParam('id_contenu', 'int');
				$id_dossier = lireParam('id_dossier', 'int');
				$id_rubrique = lireParam('id_rubrique', 'int');
				$id_produit = lireParam('id_produit', 'int');
			}

        	switch(strtolower($fond))
        	{
        		case 'dossier':
        			if($this->charger($id_dossier, $fond)) //Recherche d'un fond spécifique
					{
						$fond = $this->fond;
					}
					else //Recherche d'un fond hérité
					{
						$dossier = new Dossier();
						if($dossier->charger($id_dossier))
						{
							$parent = $dossier->parent;
							while($parent!=0)
							{
								if($this->charger($parent, $fond, 1))
								{
									$fond = $this->fond;
									break;
								}
								elseif($dossier->charger($parent))
								{
									$parent = $dossier->parent;
								}
								else
								{
									$parent = 0;
								}
							}
						}
					}
        			break;
        		case 'contenu':
        			if($this->charger($id_contenu, $fond, 0)) //Recherche d'un fond spécifique
					{
						$fond = $this->fond;
					}
					else //Recherche d'un fond hérité
					{
						$dossier = new Dossier();
						if($dossier->charger($id_dossier))
						{
							$parent = $dossier->id;
							while($parent!=0)
							{
								if($this->charger($parent, $fond, 1))
								{
									$fond = $this->fond;
									break;
								}
								elseif($dossier->charger($parent))
								{
									$parent = $dossier->parent;
								}
								else
								{
									$parent = 0;
								}
							}
						}
					}
        			break;
        		case 'rubrique':
        			if($this->charger($id_rubrique, $fond)) //Recherche d'un fond spécifique
					{
						$fond = $this->fond;
					}
					else //Recherche d'un fond hérité
					{
						$rubrique = new Rubrique();
						if($rubrique->charger($id_rubrique))
						{
							$parent = $rubrique->parent;
							while($parent!=0)
							{
								if($this->charger($parent, $fond, 1))
								{
									$fond = $this->fond;
									break;
								}
								elseif($rubrique->charger($parent))
								{
									$parent = $rubrique->parent;
								}
								else
								{
									$parent = 0;
								}
							}
						}
					}
        			break;
        		case 'produit':
        			if($this->charger($id_produit, $fond, 0)) //Recherche d'un fond spécifique
					{
						$fond = $this->fond;
					}
					else //Recherche d'un fond hérité
					{
						$rubrique = new Rubrique();
						if($rubrique->charger($id_rubrique))
						{
							$parent = $rubrique->id;
							while($parent!=0)
							{
								if($this->charger($parent, $fond, 1))
								{
									$fond = $this->fond;
									break;
								}
								elseif($rubrique->charger($parent))
								{
									$parent = $rubrique->parent;
								}
								else
								{
									$parent = 0;
								}
							}
						}
					}
        			break;
        	}
        	
        }
  		
        function charger($idfond, $fondbase, $id_parent=''){
        	if($id_parent===0 || $id_parent===1)
        		$search = "AND id_parent='$id_parent'";
        	else
        		$search = "";
        	return $this->getVars("SELECT * FROM $this->table WHERE idfond = $idfond AND fondbase='$fondbase' $search");
        }
         
		function chargerSpecifique($idfond, $fondbase){
        	return $this->getVars("SELECT * FROM $this->table WHERE idfond = $idfond AND fondbase='$fondbase'");
        }
                  
        function charger_id($id){
        	return $this->getVars("select * from $this->table where id=\"$id\"");
        }
	
}
	
?>
